function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
/* WooCommerce Step Filter Sorting
 * Original author: Alex Troll
 * Further changes, comments: mail@troll-winner.com
 */

(function (root, factory) {
  'use strict';

  if (typeof define === 'function' && define.amd) {
    define(['jquery'], factory);
  } else if ((typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' && typeof require === 'function') {
    module.exports = factory(require('jquery'));
  } else {
    factory(root.jQuery);
  }
})(this, function ($) {
  'use strict';

  var pluginName = 'wcsfSorting';
  var defaults = {};
  var $document = $(document);
  var Plugin = function Plugin(element, options) {
    this.element = element;
    this.options = $.extend({}, defaults, options);
    return this.init();
  };

  /**
   * Init the instance
   * @returns {this} self instance
   */
  Plugin.prototype.init = function () {
    this.$element = $(this.element);
    this.$list = this.$element.find('[data-component~="wcsf-sorting-list"]');
    this.$inputs = this.$element.find('[data-component~="wcsf-sorting-inputs"]');
    return this.initEventListeners();
  };

  /**
   * Add required event listeners
   * @returns {this} self instance
   */
  Plugin.prototype.initEventListeners = function () {
    var _this = this;
    // move item upper
    this.$element.on('click', '[data-component~="wcsf-sorting-move-up"]', function (event) {
      event.preventDefault();
      return _this.moveItemUp();
    });

    // move item lower
    this.$element.on('click', '[data-component~="wcsf-sorting-move-down"]', function (event) {
      event.preventDefault();
      return _this.moveItemDown();
    });
    return this;
  };

  /**
   * Move element upper in list
   * @returns {this} self instance
   */
  Plugin.prototype.moveItemUp = function () {
    var _this2 = this;
    this.$list.children(':selected').each(function (i, selected) {
      var $element = $(selected);
      var $input = _this2.$inputs.children("[value=\"".concat($element.val(), "\"]"));
      if ($element.prev().length <= 0) {
        return _this2;
      }
      $element.insertBefore($element.prev());
      $input.insertBefore($input.prev());
      return _this2;
    });
    this.$element.trigger('movedUp.item.sorting.wcsf', [this]);
    return this;
  };

  /**
   * Move element lower in list
   * @returns {this} self instance
   */
  Plugin.prototype.moveItemDown = function () {
    var _this3 = this;
    $(this.$list.children(':selected').get().reverse()).each(function (i, selected) {
      var $element = $(selected);
      var $input = _this3.$inputs.children("[value=\"".concat($element.val(), "\"]"));
      if ($element.next().length <= 0) {
        return _this3;
      }
      $element.insertAfter($element.next());
      $input.insertAfter($input.next());
      return _this3;
    });
    this.$element.trigger('movedDown.item.sorting.wcsf', [this]);
    return this;
  };
  $.fn[pluginName] = function (options) {
    return this.each(function () {
      if (!$.data(this, pluginName)) {
        $.data(this, pluginName, new Plugin(this, options));
      }
    });
  };
  var init = function init() {
    return $('[data-component~="wcsf-sorting"]').each(function () {
      return $(this).wcsfSorting();
    });
  };
  $document.ready(function () {
    return init();
  });
  $document.on('init.sorting.wcsf', function () {
    return init();
  });
});