function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}
function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      var F = function F() {};
      return {
        s: F,
        n: function n() {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function e(_e) {
          throw _e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var normalCompletion = true,
    didErr = false,
    err;
  return {
    s: function s() {
      it = it.call(o);
    },
    n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function e(_e2) {
      didErr = true;
      err = _e2;
    },
    f: function f() {
      try {
        if (!normalCompletion && it["return"] != null) it["return"]();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}
function _toPrimitive(input, hint) {
  if (_typeof(input) !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
/* WooCommerce Step Filter
 * Original author: troll_winner@mail.ru
 * Further changes, comments: troll_winner@mail.ru
 */
var WCSF = /*#__PURE__*/function () {
  // <editor-fold desc="Core">
  function WCSF(element) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    _classCallCheck(this, WCSF);
    var defaults = {
      documentNode: document,
      windowNode: window,
      rootSelector: 'html, body',
      preliminaryResultsCountRequestInterval: 1000,
      ajaxActions: {
        submit: 'WCSFSubmit',
        submitAndGoNext: 'WCSFSubmitAndGoNext',
        submitAndGoResults: 'WCSFSubmitAndGoResults',
        submitAndGoTo: 'WCSFSubmitAndGoTo',
        getStep: 'WCSFGetStep',
        reset: 'WCSFReset',
        getPreliminaryResultsCount: 'WCSFGetPreliminaryResultsCount'
      }
    };
    this.element = element;
    this.customOptions = options;
    this.options = Object.assign({}, defaults, options);
  }

  /**
   * Init the instance
   * @returns {this} self instance
   */
  _createClass(WCSF, [{
    key: "init",
    value: function init() {
      this.controlsPreliminaryResults = this.element.querySelector('[data-component~="wcsf-controls-preliminary-results"]'); // eslint-disable-line max-len
      this.getPreliminaryResultsCountTimeout = null;
      this.getPreliminaryResultsCountPromise = null;
      this.preventAjaxRequest = false;
      this.eventListeners = [];
      return this.initEventListeners().triggerEvent('launched.wcsf', {
        instance: this
      });
    }

    /**
     * Delegate an event listener to a target
     * @param {String} action - event action name
     * @param {String} selector - target element selector
     * @param {Function} callback - function to fire
     * @param {Object} options - listener options
     * @returns {this} self instance
     */
  }, {
    key: "delegateEventListener",
    value: function delegateEventListener(action, selector, callback) {
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {
        capture: false
      };
      var actionName = action.split('.')[0];
      var handler = function handler(event) {
        var target = event.target;
        while (target && !target.matches(selector) && target !== this) {
          target = target.parentElement;
        }
        if (target && target.matches(selector)) {
          callback.call(target, event);
        }
        return this;
      };
      this.eventListeners.push({
        action: action,
        actionName: actionName,
        selector: selector,
        handler: handler
      });
      this.element.addEventListener(actionName, handler, options);
      return this;
    }

    /**
     * Un-delegate an event listener from the target
     * @param {String} action - event action name
     * @param {String} selector - target element selector
     * @param {Object} options - listener options
     * @returns {this} self instance
     */
  }, {
    key: "unDelegateEventListener",
    value: function unDelegateEventListener(action) {
      var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
        capture: false
      };
      var events = this.eventListeners.filter(function (item) {
        return item.action === action && (!selector || item.selector === selector);
      });
      if (events[0]) {
        this.element.removeEventListener(events[0].actionName, events[0].handler, options);
      }
      return this;
    }

    /**
     * Add required event listeners
     * @returns {this} self instance
     */
  }, {
    key: "initEventListeners",
    value: function initEventListeners() {
      var _this2 = this;
      var _this = this;

      // reset click
      this.delegateEventListener('click.reset.wcsf', '[data-component~="wcsf-reset"]', function (event) {
        event.preventDefault();
        return _this2.reset();
      });

      // value item remove click
      this.delegateEventListener('click.remove.value.wcsf', '[data-component~="wcsf-value-item-remove"]', function (event) {
        // eslint-disable-line
        event.preventDefault();
        return _this.reset({
          resetStepId: this.getAttribute('data-id')
        });
      });

      // submit and go to click
      this.delegateEventListener('click.submitAndGoTo.wcsf', '[data-component~="wcsf-submit-and-go-to"]:not(input), [data-component~="wcsf-submit-and-go-to"]:not(select)',
      // eslint-disable-line
      function (event) {
        if (!_this.checkFromValidity()) {
          return this;
        }
        event.preventDefault();
        return _this.submitAndGoTo({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit and go to change
      this.delegateEventListener('change.submitAndGoTo.wcsf', 'input[data-component~="wcsf-submit-and-go-to"], select[data-component~="wcsf-submit-and-go-to"]',
      // eslint-disable-line
      function () {
        if (!_this.checkFromValidity()) {
          return this;
        }
        return _this.submitAndGoTo({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit and go next click
      this.delegateEventListener('click.submitAndGoNext.wcsf', '[data-component~="wcsf-submit-and-go-next"]:not(input), [data-component~="wcsf-submit-and-go-next"]:not(select)',
      // eslint-disable-line
      function (event) {
        if (!_this.checkFromValidity()) {
          return this;
        }
        event.preventDefault();
        return _this.submitAndGoNext({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit and go next change
      this.delegateEventListener('change.submitAndGoNext.wcsf', 'input[data-component~="wcsf-submit-and-go-next"], select[data-component~="wcsf-submit-and-go-next"]', function () {
        if (!_this.checkFromValidity()) {
          return this;
        }
        return _this.submitAndGoNext({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit and go to results click
      this.delegateEventListener('click.submitAndGoResults.wcsf', '[data-component~="wcsf-submit-and-go-results"]:not(input), [data-component~="wcsf-submit-and-go-results"]:not(select)',
      // eslint-disable-line
      function (event) {
        if (!_this.checkFromValidity()) {
          return this;
        }
        event.preventDefault();
        return _this.submitAndGoResults({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit and go to results change
      this.delegateEventListener('change.submitAndGoResults.wcsf', 'input[data-component~="wcsf-submit-and-go-results"], select[data-component~="wcsf-submit-and-go-results"]', function () {
        if (!_this.checkFromValidity()) {
          return this;
        }
        return _this.submitAndGoResults({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit click
      this.delegateEventListener('click.submit.wcsf', '[data-component~="wcsf-submit"]:not(input), [data-component~="wcsf-submit"]:not(select)', function (event) {
        if (!_this.checkFromValidity()) {
          return this;
        }
        event.preventDefault();
        return _this.submit({
          stepId: this.getAttribute('data-id')
        });
      });

      // submit change
      this.delegateEventListener('change.submit.wcsf', 'input[data-component~="wcsf-submit"], select[data-component~="wcsf-submit"]', function () {
        if (!_this.checkFromValidity()) {
          return this;
        }
        return _this.submit({
          stepId: this.getAttribute('data-id')
        });
      });

      // results click
      this.delegateEventListener('click.results.wcsf', '[data-component~="wcsf-results"]', function () {
        if (_this.checkFromValidity()) {
          // need to submit the form via the usual request (without js)
          _this.element.querySelector('[data-component~="wcsf-form"]').setAttribute('data-component', 'wcsf-form-off');
        }
      });

      // none action button click
      this.delegateEventListener('click.results.wcsf', '[data-component~="wcsf-none"]', function () {
        return false;
      });

      // submit form
      this.delegateEventListener('submit.form.wcsf', '[data-component~="wcsf-form"]', function (event) {
        if (!_this.checkFromValidity()) {
          return this;
        }
        event.preventDefault();
        return _this.submitAndGoNext();
      });

      // get step click
      this.delegateEventListener('click.getStep.wcsf', '[data-component~="wcsf-get-step"]', function (event) {
        event.preventDefault();
        return _this.getStep({
          stepId: this.getAttribute('data-id'),
          extraQueryArgs: {
            paged: this.getAttribute('data-page') || 1
          }
        });
      });

      // products order change
      this.delegateEventListener('change.order.wcsf', '[data-component~="wcsf-ordering-select"]', function (event) {
        event.preventDefault();
        return _this.getStep({
          extraQueryArgs: {
            orderby: this.value
          }
        });
      });

      // get preliminary results
      this.delegateEventListener('change.getPreliminaryResults.wcsf changed.getPreliminaryResults.wcsf', '[data-component~="wcsf-get-preliminary-results-count"]', function (event) {
        event.preventDefault();
        return _this.getPreliminaryResultsCount(this);
      });
      return this;
    }

    /**
     * Makes an ajax-request
     * @param {Object} data - object of data
     * @param {Object} options - object of method options
     * @param {String} method - type of the request (get, post)
     * @returns {Promise} ajax request
     */
  }, {
    key: "ajaxRequest",
    value: function ajaxRequest(data) {
      var _this3 = this;
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'post';
      this.preventAjaxRequest = false;
      var instance = this;
      var formData = data instanceof FormData ? data : new FormData();
      var defaultOptions = {
        processData: false,
        contentType: false,
        cache: 'default',
        scrollingTopOnUpdate: Boolean(this.options.scrollingTopOnUpdate),
        scrollingGap: Number(this.options.scrollingUpGap),
        scrollingBehavior: 'smooth',
        scrollingToElement: null,
        errorsAlerting: true,
        errorsLogging: true
      };
      options = this.extendObject(defaultOptions, options);

      // save extra parameters
      for (var key in this.customOptions) {
        if (!formData.has(key) && this.customOptions.hasOwnProperty(key)) {
          formData.append(key, this.customOptions[key]);
        }
      }

      // pass extra args
      if (!(data instanceof FormData)) {
        for (var _key in data) {
          if (!formData.has(_key) && data.hasOwnProperty(_key) && data[_key] !== null) {
            formData.append(_key, typeof data[_key] !== 'string' ? JSON.stringify(data[_key]) : data[_key]);
          }
        }
      }
      clearTimeout(this.getPreliminaryResultsCountTimeout);
      if (this.getPreliminaryResultsCountPromise && this.getPreliminaryResultsCountPromise.abort) {
        this.getPreliminaryResultsCountPromise.abort();
      }
      if (this.options && this.options.resetFilterOnShowing) {
        this.setQueryArg({
          'wcsf-submit': this.options.id
        });
      }
      this.triggerEvent('ajaxRequest.wcsf', {
        instance: instance,
        formData: formData,
        options: options
      });
      if (this.preventAjaxRequest) {
        this.triggerEvent('ajaxPrevent.wcsf', {
          instance: instance,
          formData: formData,
          options: options
        });
        return Promise.resolve();
      }
      this.element.classList.add('is-loading');
      this.element.setAttribute('aria-live', 'polite');
      this.element.setAttribute('aria-busy', 'true');
      return this.options.windowNode.fetch(this.options.ajaxUrl, {
        method: method,
        body: formData,
        cache: options.cache
      }).then(function (response) {
        return response.json();
      }).then(function (response) {
        // make redirect only
        if (response.redirect) {
          _this3.options.documentNode.location = response.redirect;
          return _this3;
        }
        _this3.triggerEvent('ajaxSuccess.wcsf', {
          instance: instance,
          response: response,
          formData: formData,
          options: options
        });
        _this3.element.classList.remove('is-loading');
        _this3.element.setAttribute('aria-busy', 'false');
        if (response.content) {
          _this3.element.innerHTML = response.content;
        }

        // scroll navs
        var _iterator = _createForOfIteratorHelper(_this3.element.querySelectorAll('[data-component~="wcsf-nav"]')),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var nav = _step.value;
            nav.querySelector('[data-component~="wcsf-nav-list"]').scrollLeft = nav.querySelector('.active').offsetLeft;
          }

          // scroll window
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        if (options.scrollingTopOnUpdate) {
          var element = _this3.element.querySelector(options.scrollingToElement || '[data-component~="wcsf-step"].is-active');
          if (element && !_this3.isScrolledIntoView(element)) {
            _this3.scrollToElement(element, Number(options.scrollingGap), options.scrollingBehavior);
          }
        }

        // preliminary results value
        _this3.controlsPreliminaryResults = _this3.element.querySelector('[data-component~="wcsf-controls-preliminary-results"]'); // eslint-disable-line

        // change query args
        if (response.hasOwnProperty('stateHash')) {
          _this3.setQueryArg({
            'wcsf-state': response.stateHash
          });
        }
        _this3.triggerEvent('ajaxCompleted.wcsf', {
          instance: instance,
          response: response,
          formData: formData,
          options: options
        });
        return response;
      })["catch"](function (error) {
        _this3.triggerEvent('ajaxError.wcsf', {
          instance: instance,
          error: error,
          formData: formData,
          options: options
        });
        _this3.element.classList.remove('is-loading');
        _this3.element.setAttribute('aria-busy', 'false');
        if (options.errorsLogging) {
          _this3.options.windowNode.console.error(error);
        }
        if (options.errorsAlerting) {
          _this3.options.windowNode.alert("Unexpected error occurred: ".concat(error));
        }
      });
    }

    /**
     * Dispatch an event
     * @param {String} name - event name
     * @param {Object} options - object of arguments
     * @returns {this} self instance
     */
  }, {
    key: "triggerEvent",
    value: function triggerEvent(name) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.element.dispatchEvent(new CustomEvent(name, {
        bubbles: true,
        detail: options
      }));
      return this;
    }

    /**
     * Get current filter form data
     * @param {Object} data - extra data to pass
     * @returns {FormData} value
     */
  }, {
    key: "getFormData",
    value: function getFormData() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var formData = new FormData(this.element.querySelector('[data-component~="wcsf-form"]'));
      for (var key in data) {
        if (data.hasOwnProperty(key) && data[key] !== null) {
          formData.append(key, typeof data[key] !== 'string' ? JSON.stringify(data[key]) : data[key]);
        }
      }
      return formData;
    }
    // </editor-fold>

    // <editor-fold desc="Nav">
    /**
     * Submit step
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "submit",
    value: function submit() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.submit
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }

    /**
     * Submit step and go next
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "submitAndGoNext",
    value: function submitAndGoNext() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.submitAndGoNext
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }

    /**
     * Submit step and go to results
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "submitAndGoResults",
    value: function submitAndGoResults() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.submitAndGoResults
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }

    /**
     * Submit step and get another one by id
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "submitAndGoTo",
    value: function submitAndGoTo() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.submitAndGoTo
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }

    /**
     * Get step by id
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "getStep",
    value: function getStep() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.getStep
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }

    /**
     * Reset form to the first step
     * @param {Object} args - object of arguments
     * @returns {Promise} ajax request
     */
  }, {
    key: "reset",
    value: function reset() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      args = this.extendObject({
        action: this.options.ajaxActions.reset
      }, args);
      return this.ajaxRequest(this.getFormData(args));
    }
    // </editor-fold>

    /**
     * Make a preliminary results query
     * @param {HTMLElement} element - HTML element to work with
     * @returns {this} self instance
     */
  }, {
    key: "getPreliminaryResultsCount",
    value: function getPreliminaryResultsCount(element) {
      var _this4 = this;
      var formData = this.getFormData({
        action: this.options.ajaxActions.getPreliminaryResultsCount
      });
      clearTimeout(this.getPreliminaryResultsCountTimeout);
      if (this.getPreliminaryResultsCountPromise && this.getPreliminaryResultsCountPromise.abort) {
        this.getPreliminaryResultsCountPromise.abort();
      }

      // save extra parameters
      for (var key in this.customOptions) {
        if (this.customOptions.hasOwnProperty(key)) {
          formData.append(key, typeof this.customOptions[key] !== 'string' ? JSON.stringify(this.customOptions[key]) : this.customOptions[key]);
        }
      }

      // pass cart to the server
      this.getPreliminaryResultsCountTimeout = setTimeout(function () {
        _this4.getPreliminaryResultsCountPromise = _this4.options.windowNode.fetch(_this4.options.ajaxUrl, {
          method: 'post',
          cache: 'default',
          body: formData
        }).then(function (response) {
          return response.json();
        }).then(function (response) {
          _this4.triggerEvent('getPreliminaryResultsCount.wcsf', {
            instance: _this4,
            response: response,
            element: element
          });
          if (response.controls && _this4.controlsPreliminaryResults) {
            _this4.controlsPreliminaryResults.innerHTML = response.controls;
          }
        })["catch"](function (error) {
          if (status !== 'abort') {
            _this4.options.windowNode.console.error("Unexpected error occurred: ".concat(error));
          }
        });
      }, this.options.preliminaryResultsCountRequestInterval);
      return this;
    }

    // <editor-fold desc="Utils">
    /**
     * Check HTML form validity
     * @param {HTMLFormElement} form - jQuery object
     * @returns {Boolean} is valid
     */
  }, {
    key: "checkFromValidity",
    value: function checkFromValidity() {
      var form = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var isValid = true;
      if (!form) {
        form = this.options.documentNode.querySelector('[data-component~="wcsf-form"]');
        if (typeof form.checkValidity !== 'undefined') {
          return form.checkValidity();
        }
      }

      // fallback
      var _iterator2 = _createForOfIteratorHelper(form.querySelectorAll('input, select, textarea')),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var element = _step2.value;
          if (element.required && element.value === '') {
            isValid = false;
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return isValid;
    }

    /**
     * Get current URL search params
     * @returns {object} URLSearchParams
     */
  }, {
    key: "getQueryArgs",
    value: function getQueryArgs() {
      if (typeof URLSearchParams === 'undefined') {
        return {};
      }
      return new URLSearchParams(this.options.windowNode.location.search);
    }

    /**
     * Set URL request parameter value
     * @param {Object} args - key pair of params
     * @returns {this} self instance
     */
  }, {
    key: "setQueryArg",
    value: function setQueryArg(args) {
      if (!this.options.windowNode.history || !this.options.windowNode.history.pushState) {
        return this;
      }
      var queryArgs = this.getQueryArgs();
      if (!queryArgs.get) {
        return this;
      }
      for (var key in args) {
        if (args.hasOwnProperty(key)) {
          if (typeof args[key] === 'boolean' && !args[key]) {
            queryArgs["delete"](key);
          } else {
            queryArgs.set(key, args[key]);
          }
        }
      }
      var path = this.options.windowNode.location.protocol + '//' + this.options.windowNode.location.host + this.options.windowNode.location.pathname + '?' + queryArgs.toString();
      this.options.windowNode.history.pushState({
        path: path
      }, '', path);
      return this;
    }

    /**
     * Send vibration signal
     * @param {Array} args - vibration pattern as duration, pause, duration,..
     * @returns {this} self instance
     */
  }, {
    key: "vibrate",
    value: function vibrate() {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [200];
      if ('vibrate' in this.options.windowNode.navigator) {
        this.options.windowNode.navigator.vibrate(args);
      } else if ('oVibrate' in this.options.windowNode.navigator) {
        this.options.windowNode.navigator.oVibrate(args);
      } else if ('mozVibrate' in this.options.windowNode.navigator) {
        this.options.windowNode.navigator.mozVibrate(args);
      } else if ('webkitVibrate' in this.options.windowNode.navigator) {
        this.options.windowNode.navigator.webkitVibrate(args);
      }
      return this;
    }

    /**
     * Is element on the screen
     * @param {HTMLElement} element - element to check
     * @param {Boolean} strict - check element bottom position also
     * @returns {Boolean} function result
     */
  }, {
    key: "isScrolledIntoView",
    value: function isScrolledIntoView(element) {
      var strict = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var rect = element.getBoundingClientRect();
      return !strict && rect.top >= 0 && rect.top <= this.options.windowNode.innerHeight || strict && rect.top >= 0 && rect.bottom <= this.options.windowNode.innerHeight;
    }

    /**
     * Scroll window screen to element
     * @param {HTMLElement} element - scroll to element
     * @param {Number} gap - top space gap
     * @param {String} behavior - animation behavior
     * @returns {this} self instance
     */
  }, {
    key: "scrollToElement",
    value: function scrollToElement(element) {
      var gap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var behavior = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'smooth';
      var reduceMotion = this.options.windowNode.matchMedia('(prefers-reduced-motion: reduce)') === true || this.options.windowNode.matchMedia('(prefers-reduced-motion: reduce)').matches === true;
      this.options.windowNode.scrollTo({
        top: element.getBoundingClientRect().top - Number(gap),
        behavior: reduceMotion ? 'instant' : behavior
      });
      return this;
    }

    /**
     * Extend object properties by other objects
     * @param {Object} args - object to extend
     * @returns {Object} new extended object
     */
  }, {
    key: "extendObject",
    value: function extendObject() {
      for (var _len = arguments.length, args = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
        args[_key2] = arguments[_key2];
      }
      return Object.assign.apply(Object, [{}].concat(args));
    }
  }]);
  return WCSF;
}();
export default WCSF;