function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
/* WooCommerce Step Filter
 * Original author: Alex Troll
 * Further changes, comments: mail@troll-winner.com
 */
(function (root, factory) {
  'use strict';

  if (typeof define === 'function' && define.amd) {
    define(['jquery'], factory);
  } else if ((typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' && typeof require === 'function') {
    module.exports = factory(require('jquery'));
  } else {
    factory(root.jQuery);
  }
})(this, function ($) {
  'use strict';

  var pluginName = 'wcsf';
  var defaults = {
    documentNode: document,
    windowNode: window,
    rootSelector: 'html, body',
    preliminaryResultsCountRequestInterval: 1000,
    ajaxActions: {
      submit: 'WCSFSubmit',
      submitAndGoNext: 'WCSFSubmitAndGoNext',
      submitAndGoResults: 'WCSFSubmitAndGoResults',
      submitAndGoTo: 'WCSFSubmitAndGoTo',
      getStep: 'WCSFGetStep',
      reset: 'WCSFReset',
      getPreliminaryResultsCount: 'WCSFGetPreliminaryResultsCount'
    }
  };
  var Plugin = function Plugin(element, options) {
    this.element = element;
    this.customOptions = options;
    this.options = $.extend({}, defaults, options);
    return this.init();
  };

  // <editor-fold desc="Core">
  /**
   * Init the instance
   * @returns {this} self instance
   */
  Plugin.prototype.init = function () {
    this.$element = $(this.element);
    this.$root = $(this.options.rootSelector);
    this.controlsPreliminaryResults = this.element.querySelector('[data-component~="wcsf-controls-preliminary-results"]'); // eslint-disable-line max-len
    this.getPreliminaryResultsCountTimeout = null;
    this.getPreliminaryResultsCountPromise = null;
    this.preventAjaxRequest = false;
    return this.initEventListeners().triggerEvent('launched.wcsf', [this]);
  };

  /**
   * Add required event listeners
   * @returns {this} self instance
   */
  Plugin.prototype.initEventListeners = function () {
    var _this2 = this;
    var _this = this;

    // browser history handlers
    this.options.windowNode.addEventListener('popstate', function (event) {
      return _this2.popState(event);
    }, false);

    // reset click
    this.$element.on('click.reset.wcsf', '[data-component~="wcsf-reset"]', function (event) {
      event.preventDefault();
      return _this2.reset();
    });

    // value item remove click
    this.$element.on('click.remove.value.wcsf', '[data-component~="wcsf-value-item-remove"]', function (event) {
      event.preventDefault();
      return _this.reset({
        resetStepId: this.getAttribute('data-id')
      });
    });

    // submit and go to click
    this.$element.on('click.submitAndGoTo.wcsf', '[data-component~="wcsf-submit-and-go-to"]:not(input), [data-component~="wcsf-submit-and-go-to"]:not(select)',
    // eslint-disable-line
    function (event) {
      if (!_this.checkFromValidity()) {
        return this;
      }
      event.preventDefault();
      return _this.submitAndGoTo({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit and go to change
    this.$element.on('change.submitAndGoTo.wcsf', 'input[data-component~="wcsf-submit-and-go-to"], select[data-component~="wcsf-submit-and-go-to"]',
    // eslint-disable-line
    function () {
      if (!_this.checkFromValidity()) {
        return this;
      }
      return _this.submitAndGoTo({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit and go next click
    this.$element.on('click.submitAndGoNext.wcsf', '[data-component~="wcsf-submit-and-go-next"]:not(input), [data-component~="wcsf-submit-and-go-next"]:not(select)',
    // eslint-disable-line
    function (event) {
      if (!_this.checkFromValidity()) {
        return this;
      }
      event.preventDefault();
      return _this.submitAndGoNext({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit and go next change
    this.$element.on('change.submitAndGoNext.wcsf', 'input[data-component~="wcsf-submit-and-go-next"], select[data-component~="wcsf-submit-and-go-next"]', function () {
      if (!_this.checkFromValidity()) {
        return this;
      }
      return _this.submitAndGoNext({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit and go to results click
    this.$element.on('click.submitAndGoResults.wcsf', '[data-component~="wcsf-submit-and-go-results"]:not(input), [data-component~="wcsf-submit-and-go-results"]:not(select)',
    // eslint-disable-line
    function (event) {
      if (!_this.checkFromValidity()) {
        return this;
      }
      event.preventDefault();
      return _this.submitAndGoResults({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit and go to results change
    this.$element.on('change.submitAndGoResults.wcsf', 'input[data-component~="wcsf-submit-and-go-results"], select[data-component~="wcsf-submit-and-go-results"]', function () {
      if (!_this.checkFromValidity()) {
        return this;
      }
      return _this.submitAndGoResults({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit click
    this.$element.on('click.submit.wcsf', '[data-component~="wcsf-submit"]:not(input), [data-component~="wcsf-submit"]:not(select)', function (event) {
      if (!_this.checkFromValidity()) {
        return this;
      }
      event.preventDefault();
      return _this.submit({
        stepId: this.getAttribute('data-id')
      });
    });

    // submit change
    this.$element.on('change.submit.wcsf', 'input[data-component~="wcsf-submit"], select[data-component~="wcsf-submit"]', function () {
      if (!_this.checkFromValidity()) {
        return this;
      }
      return _this.submit({
        stepId: this.getAttribute('data-id')
      });
    });

    // results click
    this.$element.on('click.results.wcsf', '[data-component~="wcsf-results"]', function () {
      if (_this.checkFromValidity()) {
        // need to submit the form via the usual request (without js)
        _this.element.querySelector('[data-component~="wcsf-form"]').setAttribute('data-component', 'wcsf-form-off');
      }
    });

    // none action button click
    this.$element.on('click.results.wcsf', '[data-component~="wcsf-none"]', function () {
      return false;
    });

    // submit form
    this.$element.on('submit.form.wcsf', '[data-component~="wcsf-form"]', function (event) {
      if (!_this.checkFromValidity()) {
        return this;
      }
      event.preventDefault();
      return _this.submitAndGoNext();
    });

    // get step click
    this.$element.on('click.getStep.wcsf', '[data-component~="wcsf-get-step"]', function (event) {
      event.preventDefault();
      return _this.getStep({
        stepId: this.getAttribute('data-id'),
        extraQueryArgs: {
          paged: this.getAttribute('data-page') || 1
        }
      });
    });

    // products order change
    this.$element.on('change.order.wcsf', '[data-component~="wcsf-ordering-select"]', function (event) {
      event.preventDefault();
      return _this.getStep({
        extraQueryArgs: {
          orderby: this.value
        }
      });
    });

    // get preliminary results
    this.$element.on('change.getPreliminaryResults.wcsf changed.getPreliminaryResults.wcsf', '[data-component~="wcsf-get-preliminary-results-count"]', function (event) {
      event.preventDefault();
      return _this.getPreliminaryResultsCount(this);
    });
    return this;
  };

  /**
   * Makes an ajax-request
   * @param {Object} requestData - object of data
   * @param {Object} options - object of method options
   * @returns {Promise} ajax request
   */
  Plugin.prototype.ajaxRequest = function (requestData) {
    var _this3 = this;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    this.preventAjaxRequest = false;
    var formData = requestData instanceof FormData ? requestData : new FormData();
    var defaultOptions = {
      updateQueryArgs: true,
      queryArgs: {},
      processData: false,
      contentType: false,
      cache: false,
      method: 'post',
      scrollingTopOnUpdate: Boolean(this.options.scrollingTopOnUpdate),
      scrollingGap: Number(this.options.scrollingUpGap),
      scrollingSpeed: 500,
      scrollingToElement: null,
      errorsAlerting: true,
      errorsLogging: true
    };
    options = this.extendObject(defaultOptions, options);

    // pass extra args
    if (!(requestData instanceof FormData)) {
      for (var key in requestData) {
        if (!formData.has(key) && requestData.hasOwnProperty(key) && requestData[key] !== null) {
          formData.append(key, typeof requestData[key] !== 'string' ? JSON.stringify(requestData[key]) : requestData[key]);
        }
      }
    }

    // save extra parameters
    for (var _key in this.customOptions) {
      if (!formData.has(_key) && this.customOptions.hasOwnProperty(_key)) {
        formData.append(_key, typeof this.customOptions[_key] !== 'string' ? JSON.stringify(this.customOptions[_key]) : this.customOptions[_key]);
      }
    }

    // save passed query args to request
    if (options.queryArgs) {
      for (var _key2 in options.queryArgs) {
        if (options.queryArgs.hasOwnProperty(_key2)) {
          formData.append(_key2, options.queryArgs[_key2]);
        }
      }
    }
    clearTimeout(this.getPreliminaryResultsCountTimeout);
    if (this.getPreliminaryResultsCountPromise && this.getPreliminaryResultsCountPromise.abort) {
      this.getPreliminaryResultsCountPromise.abort();
    }
    this.triggerEvent('ajaxRequest.wcsf', [this, formData, options]);
    if (this.preventAjaxRequest) {
      this.triggerEvent('ajaxPrevent.wcsf', [this, formData, options]);
      return $.when();
    }
    this.$element.addClass('is-loading');
    this.element.setAttribute('aria-live', 'polite');
    this.element.setAttribute('aria-busy', 'true');
    return $.ajax({
      url: this.options.ajaxUrl,
      method: options.method,
      data: formData,
      processData: options.processData,
      contentType: options.contentType,
      cache: options.cache,
      success: function success(response) {
        _this3.triggerEvent('ajaxSuccess.wcsf', [_this3, response, formData, options]);

        // make redirect only
        if (response.finalRedirectUrl) {
          _this3.triggerEvent('finalRedirect.wcsf', [_this3, formData, response]);
          _this3.options.documentNode.location = response.finalRedirectUrl;
          return _this3;
        }
        _this3.$element.removeClass('is-loading');
        _this3.element.setAttribute('aria-busy', 'false');
        if (response.content) {
          _this3.$element.html(response.content);
        }

        // scroll navs
        var _iterator = _createForOfIteratorHelper(_this3.element.querySelectorAll('[data-component~="wcsf-nav"]')),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var nav = _step.value;
            var navList = nav.querySelector('[data-component~="wcsf-nav-list"]');
            if (navList) {
              navList.scrollLeft = nav.querySelector('.active').offsetLeft;
            }
          }

          // scroll window
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        if (options.scrollingTopOnUpdate) {
          var element = _this3.element.querySelector(options.scrollingToElement || '[data-component~="wcsf-step"].is-active');
          if (element && !_this3.isScrolledIntoView(element)) {
            _this3.scrollToElement(element, Number(options.scrollingGap), Number(options.scrollingSpeed));
          }
        }

        // preliminary results value
        _this3.controlsPreliminaryResults = _this3.element.querySelector('[data-component~="wcsf-controls-preliminary-results"]'); // eslint-disable-line

        if (options.updateQueryArgs && options.queryArgs) {
          if (_this3.options && _this3.options.resetFilterOnShowing) {
            options.queryArgs['wcsf-submit'] = _this3.options.id;
          }
          if (response.hasOwnProperty('stateHash')) {
            options.queryArgs['wcsf-state-hash'] = response.stateHash;
          }
          if (response.hasOwnProperty('stepId')) {
            options.queryArgs['wcsf-step'] = response.stepId;
          }
          if (Object.keys(options.queryArgs).filter(function (item) {
            return options.queryArgs[item] !== false;
          }).length !== 0) {
            _this3.setQueryArg(options.queryArgs);
          }
        }
        _this3.triggerEvent('ajaxCompleted.wcsf', [_this3, response, formData, options]);
        return response;
      },
      error: function error(xhr, status, _error) {
        _this3.triggerEvent('ajaxError.wcsf', [_this3, _error, formData, options]);
        _this3.$element.removeClass('is-loading');
        _this3.element.setAttribute('aria-busy', 'false');
        if (options.errorsLogging) {
          _this3.options.windowNode.console.error(xhr, status, _error);
        }
        if (options.errorsAlerting) {
          _this3.options.windowNode.alert("Unexpected error occurred: ".concat(xhr.status, ", ").concat(xhr.statusText));
        }
        return _error;
      }
    });
  };

  /**
   * Dispatch an event
   * @param {String} name - event name
   * @param {Array} options - array of arguments
   * @returns {this} self instance
   */
  Plugin.prototype.triggerEvent = function (name) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    this.$element.trigger(name, options);
    return this;
  };

  /**
   * Get a step by the previous state
   * @param {PopStateEvent} event - window history pop event
   * @returns {Promise} ajax request
   */
  Plugin.prototype.popState = function (event) {
    var requestArgs = {
      action: this.options.ajaxActions.getStep
    };
    var openingPath = event && event.state && event.state.path;
    if (!openingPath) {
      return $.when();
    }
    var queryArgs = new URL(openingPath).searchParams;
    if (queryArgs.has('wcsf-step')) {
      requestArgs.stepId = queryArgs.get('wcsf-step');
    }
    return this.ajaxRequest(requestArgs, {
      updateQueryArgs: false
    });
  };

  /**
   * Get current filter form data
   * @param {Object} data - extra data to pass
   * @returns {FormData} value
   */
  Plugin.prototype.getFormData = function () {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var formData = new FormData(this.element.querySelector('[data-component~="wcsf-form"]'));
    for (var key in data) {
      if (data.hasOwnProperty(key) && data[key] !== null) {
        formData.append(key, typeof data[key] !== 'string' ? JSON.stringify(data[key]) : data[key]);
      }
    }
    return formData;
  };
  // </editor-fold>

  // <editor-fold desc="Nav">
  /**
   * Submit step
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.submit = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.submit
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };

  /**
   * Submit step and go next
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.submitAndGoNext = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.submitAndGoNext
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };

  /**
   * Submit step and go to results
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.submitAndGoResults = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.submitAndGoResults
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };

  /**
   * Submit step and get another one by id
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.submitAndGoTo = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.submitAndGoTo
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };

  /**
   * Get step by id
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.getStep = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.getStep
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };

  /**
   * Reset form to the first step
   * @param {Object} args - object of arguments
   * @returns {Promise} ajax request
   */
  Plugin.prototype.reset = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    args = this.extendObject({
      action: this.options.ajaxActions.reset
    }, args);
    return this.ajaxRequest(this.getFormData(args));
  };
  // </editor-fold>

  /**
   * Make a preliminary results query
   * @param {HTMLElement} element - HTML element to work with
   * @returns {this} self instance
   */
  Plugin.prototype.getPreliminaryResultsCount = function (element) {
    var _this4 = this;
    var formData = this.getFormData({
      action: this.options.ajaxActions.getPreliminaryResultsCount
    });
    clearTimeout(this.getPreliminaryResultsCountTimeout);
    if (this.getPreliminaryResultsCountPromise && this.getPreliminaryResultsCountPromise.abort) {
      this.getPreliminaryResultsCountPromise.abort();
    }

    // save extra parameters
    for (var key in this.customOptions) {
      if (this.customOptions.hasOwnProperty(key)) {
        formData.append(key, typeof this.customOptions[key] !== 'string' ? JSON.stringify(this.customOptions[key]) : this.customOptions[key]);
      }
    }

    // pass cart to the server
    this.getPreliminaryResultsCountTimeout = setTimeout(function () {
      _this4.getPreliminaryResultsCountPromise = $.ajax({
        url: _this4.options.ajaxUrl,
        method: 'post',
        data: formData,
        dataType: 'json',
        processData: false,
        contentType: false,
        cache: false,
        success: function success(response) {
          _this4.triggerEvent('getPreliminaryResultsCount.wcsf', [_this4, response, element]);
          if (response.controls && _this4.controlsPreliminaryResults) {
            _this4.controlsPreliminaryResults.innerHTML = response.controls;
          }
        },
        error: function error(xhr, status, _error2) {
          if (status !== 'abort') {
            _this4.options.windowNode.console.error(xhr, status, _error2);
          }
        }
      });
    }, this.options.preliminaryResultsCountRequestInterval);
    return this;
  };

  // <editor-fold desc="Utils">
  /**
   * Check HTML form validity
   * @param {HTMLFormElement} form - jQuery object
   * @returns {Boolean} is valid
   */
  Plugin.prototype.checkFromValidity = function () {
    var form = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    var isValid = true;
    if (!form) {
      form = this.options.documentNode.querySelector('[data-component~="wcsf-form"]');
      if (typeof form.checkValidity !== 'undefined') {
        return form.checkValidity();
      }
    }

    // fallback
    var _iterator2 = _createForOfIteratorHelper(form.querySelectorAll('input, select, textarea')),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var element = _step2.value;
        if (element.required && element.value === '') {
          isValid = false;
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return isValid;
  };

  /**
   * Get current URL search params
   * @param {String} search - GET string to parse
   * @returns {object} URLSearchParams
   */
  Plugin.prototype.getQueryArgs = function () {
    var search = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.options.windowNode.location.search;
    if (typeof URLSearchParams === 'undefined') {
      return {};
    }
    return new URLSearchParams(search);
  };

  /**
   * Set URL request parameter value
   * @param {Object} args - key pair of params
   * @returns {this} self instance
   */
  Plugin.prototype.setQueryArg = function (args) {
    if (!this.options.windowNode.history || !this.options.windowNode.history.pushState) {
      return this;
    }
    var queryArgs = this.getQueryArgs();
    if (!queryArgs.get) {
      return this;
    }
    for (var key in args) {
      if (args.hasOwnProperty(key)) {
        if (typeof args[key] === 'boolean' && !args[key]) {
          queryArgs["delete"](key);
        } else {
          queryArgs.set(key, args[key]);
        }
      }
    }
    var path = this.options.windowNode.location.protocol + '//' + this.options.windowNode.location.host + this.options.windowNode.location.pathname + '?' + queryArgs.toString();
    this.options.windowNode.history.pushState({
      path: path
    }, '', path);
    return this;
  };

  /**
   * Send vibration signal
   * @param {Array} args - vibration pattern as duration, pause, duration,..
   * @returns {this} self instance
   */
  Plugin.prototype.vibrate = function () {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [200];
    if ('vibrate' in this.options.windowNode.navigator) {
      this.options.windowNode.navigator.vibrate(args);
    } else if ('oVibrate' in this.options.windowNode.navigator) {
      this.options.windowNode.navigator.oVibrate(args);
    } else if ('mozVibrate' in this.options.windowNode.navigator) {
      this.options.windowNode.navigator.mozVibrate(args);
    } else if ('webkitVibrate' in this.options.windowNode.navigator) {
      this.options.windowNode.navigator.webkitVibrate(args);
    }
    return this;
  };

  /**
   * Is element on the screen
   * @param {HTMLElement} element - element to check
   * @param {Boolean} strict - check element bottom position also
   * @returns {Boolean} function result
   */
  Plugin.prototype.isScrolledIntoView = function (element) {
    var strict = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var rect = element.getBoundingClientRect();
    return !strict && rect.top >= 0 && rect.top <= this.options.windowNode.innerHeight || strict && rect.top >= 0 && rect.bottom <= this.options.windowNode.innerHeight;
  };

  /**
   * Scroll window screen to element
   * @param {HTMLElement} element - scroll to element
   * @param {Number} gap - top space gap
   * @param {Number} speed - animation speed
   * @returns {this} self instance
   */
  Plugin.prototype.scrollToElement = function (element) {
    var gap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var speed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 500;
    var reduceMotion = this.options.windowNode.matchMedia('(prefers-reduced-motion: reduce)') === true || this.options.windowNode.matchMedia('(prefers-reduced-motion: reduce)').matches === true;
    this.$root.stop().animate({
      scrollTop: element.getBoundingClientRect().top + this.options.windowNode.scrollY - Number(gap)
    }, speed * !reduceMotion);
    return this;
  };

  /**
   * Extend object properties by other objects
   * @param {Object} args - object to extend
   * @returns {Object} new extended object
   */
  Plugin.prototype.extendObject = function () {
    for (var _len = arguments.length, args = new Array(_len), _key3 = 0; _key3 < _len; _key3++) {
      args[_key3] = arguments[_key3];
    }
    return $.extend.apply($, [{}].concat(args));
  };
  // </editor-fold>

  $.fn[pluginName] = function (options) {
    return this.each(function () {
      if (!$.data(this, pluginName)) {
        $.data(this, pluginName, new Plugin(this, options));
      }
    });
  };
});