<?php
namespace WCStepFilter;

/**
 * Taxonomy Entity Interface
 *
 * @version 1.0.0
 *
 * @property string $taxonomy
 */
interface TaxonomyInterface
{
    /** Register entity taxonomy */
    public function registerTaxonomy();

    /**
     * Get category settings model array
     *
     * @return array
     */
    public static function getCategorySettingsModel();

    /**
     * Add meta-box to category edit page
     *
     * @param \WP_term $term
     */
    public function outputCategoryFields($term);

    /**
     * Save category meta fields
     *
     * @param integer $termId
     */
    public function saveCategoryFields($termId);

    /**
     * Get category setting
     *
     * @param integer $id
     * @param string $setting
     *
     * @return string|float|bool|array
     */
    public static function getCategorySetting($id, $setting);

    /**
     * Get list of categories ids and names
     *
     * @return array
     */
    public static function getCategoriesIds();
}
