<?php
defined('ABSPATH') || exit;

$id = isset($id) ? $id : null;

if (!$id) {
    throw new Exception('Empty filter id');
}

use \WCStepFilter\Filter;
use \WCStepFilter\Template;

$arguments = Template::getHTMLArgs([
    'formId' => null,
    'showResultsWithin' => Filter::getSetting($id, 'show_results_within'),
    'resultsUrl' => Filter::getSetting($id, 'results_url'),
    'resetButtonUrl' => Filter::getResetUrl($id),
    'resetButtonText' => Filter::getSetting($id, 'reset_button_text'),
    'resetButtonClass' => Filter::getSetting($id, 'reset_button_class')
]);
?>
<a href="<?php echo esc_url($arguments['resetButtonUrl']); ?>" role="button"
    class="btn wcsf-control is-reset wcsf-reset <?php echo esc_attr($arguments['resetButtonClass']); ?>"
    form="<?php echo esc_attr($arguments['formId']); ?>"
    data-component="<?php
    echo $arguments['resultsUrl'] == '#' && !$arguments['showResultsWithin'] ? 'none' : 'wcsf-reset';
    ?>"><span class="wcsf-control-inner">
        <!--spacer-->
        <?php echo wp_kses_post($arguments['resetButtonText']); ?>
        <!--spacer-->
    </span></a><!--spacer-->
