<?php
defined('ABSPATH') || exit;

$id = isset($id) ? $id : null;

if (!$id) {
    throw new Exception('Empty filter id');
}

use \WCStepFilter\Filter;
use \WCStepFilter\Template;

$arguments = Template::getHTMLArgs([
    'formId' => null,
    'skipButtonText' => Filter::getSetting($id, 'skip_button_text'),
    'skipButtonClass' => Filter::getSetting($id, 'skip_button_class'),
    'nextStepId' => Filter::getNextActiveStepId($id)
]);
?>
<button class="btn wcsf-control is-skip wcsf-skip <?php echo esc_attr($arguments['skipButtonClass']); ?>"
    type="submit" name="skip" value="<?php echo esc_attr($arguments['nextStepId']); ?>"
    form="<?php echo esc_attr($arguments['formId']); ?>"
    data-component="wcsf-skip wcsf-get-step"
    data-id="<?php echo esc_attr($arguments['nextStepId']); ?>"><span class="wcsf-control-inner">
        <!--spacer-->
        <?php echo wp_kses_post($arguments['skipButtonText']); ?>
        <!--spacer-->
    </span></button><!--spacer-->
