<?php
defined('ABSPATH') || exit;

use \WCStepFilter\Template;

$arguments = Template::getHTMLArgs([
    'formId' => null,
    'question' => null,
    'fields' => [],
    'currentValue' => []
]);
?>
<ul class="wcsf-fields-list is-multi-choice-checkbox form-group">
    <?php foreach ($arguments['fields'] as $field) { ?>
        <li class="wcsf-field is-multi-choice-checkbox<?php
            echo esc_attr(' is-value-' . str_replace(' ', '-', $field->value) . ($field->disabled ? ' disabled' : ''));
            ?>">
            <span class="wcsf-field-label"><?php
                echo wp_kses_post($field->name);

                if (isset($field->count)) {
                    echo ' <span class="wcsf-field-count">(' . wp_kses_post($field->count) . ')</span>';
                }

                if (isset($field->description) && !empty($field->description)) {
                    echo ' <span class="wcsf-field-description">' . wp_kses_post($field->description) . '</span>';
                }
                ?></span>
            <label class="wcsf-field-value">
                <span class="wcsf-field-value-inner">
                    <?php foreach ($arguments['question']->multiChoiceValues as $possibleValue) { ?>
                        <?php
                        $isChecked = isset($field->currentValue[$field->value])
                            && $field->currentValue[$field->value] == $possibleValue['value']
                            || $possibleValue['value'] == reset($arguments['question']->multiChoiceValues)['value'];
                        ?>
                        <input type="radio" class="wcsf-field-input is-<?php echo esc_attr($possibleValue['key']); ?>"
                            form="<?php echo esc_attr($arguments['formId']); ?>"
                            data-component="<?php echo esc_attr($field->component); ?>"
                            name="<?php echo esc_attr("value[{$arguments['question']->id}][$field->value]"); ?>"
                            value="<?php echo esc_attr($possibleValue['value']); ?>"<?php checked($isChecked); ?>>
                    <?php } ?>
                    <span class="wcsf-field-icon"></span>
                    <?php foreach ($arguments['question']->multiChoiceValues as $key => $possibleValue) { ?>
                        <span class="wcsf-field-name is-<?php echo esc_attr($possibleValue['key']); ?>"><?php
                            echo wp_kses_post($possibleValue['label']);
                            ?></span>
                    <?php } ?>
                </span>
            </label>
        </li>
    <?php } ?>
</ul>
