<?php
defined('ABSPATH') || exit;

$id = isset($id) ? $id : null;

if (!$id) {
    throw new Exception('Empty filter id');
}

use \WCStepFilter\Template;
use \WCStepFilter\Filter;

$arguments = Template::getHTMLArgs([
    'controls' => Filter::getSetting($id, 'header_controls'),
    'stickyHeader' => Filter::getSetting($id, 'sticky_header'),
    'stickyHeaderOffsetTop' => Filter::getSetting($id, 'sticky_header_offset_top')
]);

$isSticky = !in_array($arguments['stickyHeader'], ['0', 'never']);
$class = [];

if ($isSticky) {
    $class[] = 'is-sticky' . (!in_array($arguments['stickyHeader'], ['1', 'always']) ? "-{$arguments['stickyHeader']}" : '');
}
?>
<header class="wcsf-header <?php echo esc_attr(implode(' ', $class)); ?>"
    data-component="wcsf-header<?php echo $arguments['stickyHeader'] ? ' wcsf-sticky-observer' : ''; ?>"
    <?php
    if ($isSticky && $arguments['stickyHeaderOffsetTop']) {
        if (is_int($arguments['stickyHeaderOffsetTop'])) {
            $arguments['stickyHeaderOffsetTop'] .= 'px';
        }

        echo ' style="top: ' . esc_attr($arguments['stickyHeaderOffsetTop']) . '"';
    }
    ?>><?php Template::html('controls/index', $arguments); ?></header>
