<?php
defined('ABSPATH') || exit;

$id = isset($id) ? $id : null;

if (!$id) {
    throw new Exception('Empty filter id');
}

use \WCStepFilter\Template;
use \WCStepFilter\Filter;

$arguments = Template::getHTMLArgs([
    'showProgress' => Filter::getSetting($id, 'show_progress'),
    'progressLabel' => Filter::getSetting($id, 'progress_label'),
    'steps' => Filter::getSteps($id),
    'stepsProgress' => Filter::getStepsProgress($id)
]);

$class = ['is-progress-' . $arguments['stepsProgress']];

if (!$arguments['showProgress']) {
    return;
} elseif ($arguments['showProgress'] != 'always') {
    $class[] = "d-{$arguments['showProgress']}-none";
}

$max = count($arguments['steps']) - 1;
?>
<div class="wcsf-progress <?php echo esc_attr(implode(' ', $class)); ?>">
    <div class="wcsf-progress-line progress" role="progressbar"
        aria-label="<?php echo esc_attr($arguments['progressLabel']); ?>"
        aria-valuenow="<?php echo esc_attr($arguments['stepsProgress']); ?>"
        aria-valuemin="0" aria-valuemax="<?php echo esc_attr($max); ?>">
        <div class="wcsf-progress-line-bar progress-bar"
            style="width:<?php echo esc_attr((int) $arguments['stepsProgress'] * 100 / ($max)); ?>%;"></div>
    </div>
    <div class="wcsf-progress-label"><?php
        printf(
            $arguments['progressLabel'],
            $arguments['stepsProgress'] + 1,
            count($arguments['steps'])
        );
        ?></div>

</div>
