<?php
defined('ABSPATH') || exit;

$id = isset($id) ? $id : null;

if (!$id) {
    return;
}

use \WCStepFilter\Filter;
use \WCStepFilter\Template;

$arguments = Template::getHTMLArgs([
    'shopControls' => Filter::getSetting($id, 'shop_controls'),
    'resultsUrl' => Filter::getSetting($id, 'results_url'),
    'repeatButtonLink' => isset($_GET['wcsf-referer']) && $_GET['wcsf-referer']
        ? $_GET['wcsf-referer']
        : Filter::getSetting($id, 'shop_repeat_button_url'),
    'backButtonLink' => isset($_GET['wcsf-referer']) && $_GET['wcsf-referer']
        ? str_replace("wcsf-reset-state={$id}", '', $_GET['wcsf-referer'])
        : Filter::getSetting($id, 'shop_back_button_url')
]);

if ($arguments['resultsUrl'] == '#' || !isset($_GET['wcsf-results'])) {
    // don't show for the page with the filter or if there is no filter query
    return;
}
?>
<div class="wcsf wcsf-shop-controls"><?php
    $availableControls = [
        'spacer' => true,
        'back' => $arguments['backButtonLink'],
        'repeat' => $arguments['repeatButtonLink'],
        'reset' => true
    ];

    foreach ($arguments['shopControls'] as $control) {
        if (!isset($availableControls[$control]) || !$availableControls[$control]) {
            continue;
        }

        Template::html('shop/controls/' . $control, $arguments);
    }
    ?></div>
